﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.Mvc;

using EcoMvcExample.Model;


namespace EcoMvcExample.MvcWebsite.Views.Tasks
{
    /// <summary>
    /// 
    /// </summary>
    /// <param name="t"></param>
    /// <returns></returns>
    public partial class Details : ViewPage<Task>
    {
        /// NOTES:
        /// There are a few other security issues with this type of approach, technically, if the users
        /// are able to provide the data in the first place.  You should really just try to ensure there
        /// are no other encoding types used that the browsers would understand and interpret that would
        /// make the display of this information potentially allow smart JavaScript injection/XSS attacks.
        /// 
        /// However, for this example, this should be sufficient in the short term.
        protected string ShowNotes(Task t)
        {
            string sOutput = null;
            string sSourceNotes = t.Notes;

            if (!string.IsNullOrEmpty(sSourceNotes))
            {
                string[] arParagraphs = sSourceNotes.Split(Environment.NewLine.ToCharArray());

                StringWriter sw = new StringWriter();
                try
                {
                    XhtmlTextWriter writer = new XhtmlTextWriter(sw);
                    try
                    {
                        foreach (string s in arParagraphs)
                        {
                            writer.RenderBeginTag(HtmlTextWriterTag.P);
                            try
                            {
                                writer.Write(Html.Encode(s));
                            }
                            finally
                            {
                                writer.RenderEndTag();
                                writer.Write(writer.NewLine);
                            }
                        }
                    }
                    finally
                    {
                        writer = null;
                    }
                }
                finally
                {
                    sOutput = sw.ToString();
                    sw = null;
                }
            }
            
            return sOutput;
        }
    }
}
